package common

import (
	"bytes"
	"encoding/json"
	"io"
	"log"
	"net/http"
	"time"
)

const (
	IAMUser        = "pcmmodelarts"
	IAMPassword    = "!QAZ2wsx3edc4"
	IAMDomain      = "hw_008618597947378_01"
	AuthMethod     = "password"
	IAMTokenUrl    = "https://iam.cn-north-4.myhuaweicloud.com/v3/auth/tokens"
	ProjectName    = "cn-north-4"
	TokenHeader    = "X-Subject-Token"
	Status_created = 201
)

var (
	token, expiredAt = GenerateToken()
)

func GenerateToken() (string, time.Time) {
	a := Auth{}
	a.Auth.Scope.Project.Name = ProjectName
	a.Auth.Identity.Methods = append(a.Auth.Identity.Methods, AuthMethod)
	a.Auth.Identity.Password.User.Name = IAMUser
	a.Auth.Identity.Password.User.Password = IAMPassword
	a.Auth.Identity.Password.User.Domain.Name = IAMDomain

	jsonStr, _ := json.Marshal(a)
	req_url, err := http.NewRequest("POST", IAMTokenUrl, bytes.NewBuffer(jsonStr))

	if err != nil {
		log.Fatal(err)
	}

	c := http.Client{Timeout: time.Duration(3) * time.Second}

	respUrl, err := c.Do(req_url)
	if err != nil {
		log.Fatal(err)
	}

	if respUrl.StatusCode != Status_created {
		panic("获取token失败")
	}

	defer respUrl.Body.Close()

	var t Token

	result, _ := io.ReadAll(respUrl.Body)
	json.Unmarshal(result, &t)

	return respUrl.Header.Get(TokenHeader), t.Token.ExpiresAt
}

func GetToken() string {
	if time.Now().After(expiredAt) {
		token, expiredAt = GenerateToken()
	}
	return token
}
