package common

import "time"

type Token struct {
	Token struct {
		ExpiresAt time.Time `json:"expires_at"`
		Methods   []string  `json:"methods"`
		Catalog   []struct {
			Endpoints []struct {
				Id        string `json:"id"`
				Interface string `json:"interface"`
				Region    string `json:"region"`
				RegionId  string `json:"region_id"`
				Url       string `json:"url"`
			} `json:"endpoints"`
			Id   string `json:"id"`
			Name string `json:"name"`
			Type string `json:"type"`
		} `json:"catalog"`
		Roles []struct {
			Id   string `json:"id"`
			Name string `json:"name"`
		} `json:"roles"`
		Project struct {
			Domain struct {
				Id   string `json:"id"`
				Name string `json:"name"`
			} `json:"domain"`
			Id   string `json:"id"`
			Name string `json:"name"`
		} `json:"project"`
		IssuedAt time.Time `json:"issued_at"`
		User     struct {
			Domain struct {
				Id   string `json:"id"`
				Name string `json:"name"`
			} `json:"domain"`
			Id                string `json:"id"`
			Name              string `json:"name"`
			PasswordExpiresAt string `json:"password_expires_at"`
		} `json:"user"`
	} `json:"token"`
}

type Auth struct {
	Auth struct {
		Identity struct {
			Methods  []string `json:"methods"`
			Password struct {
				User struct {
					Name     string `json:"name"`
					Password string `json:"password"`
					Domain   struct {
						Name string `json:"name"`
					} `json:"domain"`
				} `json:"user"`
			} `json:"password"`
		} `json:"identity"`
		Scope struct {
			Project struct {
				Name string `json:"name"`
			} `json:"project"`
		} `json:"scope"`
	} `json:"auth"`
}

type Error struct {
	ErrorCode string `json:"error_code"`
	ErrorMsg  string `json:"error_msg"`
}
