package logic

import (
	"bytes"
	"context"
	"encoding/json"
	"io/ioutil"
	"log"
	"net/http"
	"time"

	"PCM/adaptor/PCM-AI/PCM-MODELARTS/rpc/internal/svc"
	"PCM/adaptor/PCM-AI/PCM-MODELARTS/rpc/modelarts"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetTokenLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewGetTokenLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetTokenLogic {
	return &GetTokenLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// getToken
func (l *GetTokenLogic) GetToken(in *modelarts.TokenReq) (*modelarts.TokenResp, error) {
	// todo: add your logic here and delete this line

	var resp modelarts.TokenResp
	TokenUrl := "v3/auth/tokens"

	jsonStr, _ := json.Marshal(in)
	reqUrl, err := http.NewRequest("POST", "https://iam.cn-north-4.myhuaweicloud.com/"+TokenUrl, bytes.NewBuffer(jsonStr))

	if err != nil {
		log.Fatal(err)
	}
	defer reqUrl.Body.Close()

	c := http.Client{Timeout: time.Duration(3) * time.Second}

	respUrl, err := c.Do(reqUrl)

	print(respUrl)

	defer respUrl.Body.Close()

	if err != nil {
		log.Fatal(err)
	}

	result, _ := ioutil.ReadAll(respUrl.Body)
	json.Unmarshal([]byte(string(result)), &resp)

	//X-Auth-Token := respUrl.Header().Get("X-Subject-Token")

	//return resp, nil

	return &modelarts.TokenResp{}, nil

}
