package svc

import (
	"PCM/adaptor/PCM-AI/PCM-MODELARTS/rpc/internal/config"
	"PCM/adaptor/PCM-CORE/rpc/pcmcoreclient"
	"github.com/robfig/cron/v3"
	"github.com/zeromicro/go-zero/zrpc"
)

type ServiceContext struct {
	Config     config.Config
	Cron       *cron.Cron
	PcmCoreRpc pcmcoreclient.PcmCore
}

func NewServiceContext(c config.Config) *ServiceContext {
	return &ServiceContext{
		Config:     c,
		Cron:       cron.New(cron.WithSeconds()),
		PcmCoreRpc: pcmcoreclient.NewPcmCore(zrpc.MustNewClient(c.PcmCoreRpcConf)),
	}
}
