package logic

import (
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/common"
	"PCM/common/tool"
	"context"

	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/svc"
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/octopus"

	"github.com/zeromicro/go-zero/core/logx"
)

type DeleteTrainJobLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewDeleteTrainJobLogic(ctx context.Context, svcCtx *svc.ServiceContext) *DeleteTrainJobLogic {
	return &DeleteTrainJobLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *DeleteTrainJobLogic) DeleteTrainJob(in *octopus.DeleteTrainJobReq) (*octopus.DeleteTrainJobResp, error) {
	resp := &octopus.DeleteTrainJobResp{}

	var url_prefix = common.OctopusUrls[in.Platform]
	var reqUrl = url_prefix + l.svcCtx.Config.OctopusApi.DeleteTrainJob

	token := common.GetToken(in.Platform)
	req := tool.GetACHttpRequest()

	var queryStr string
	for _, s := range in.GetJobIds() {
		queryStr += "jobIds=" + s + "&"
	}
	_, err := req.
		SetHeader("Authorization", "Bearer "+token).
		SetQueryString(queryStr).
		SetResult(resp).
		Delete(reqUrl)

	if err != nil {
		return nil, err
	}

	return resp, nil
}
