package logic

import (
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/common"
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/svc"
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/octopus"
	"PCM/common/tool"
	"context"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetTrainJobLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewGetTrainJobLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetTrainJobLogic {
	return &GetTrainJobLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *GetTrainJobLogic) GetTrainJob(in *octopus.GetTrainJobReq) (*octopus.GetTrainJobResp, error) {
	resp := &octopus.GetTrainJobResp{}

	var url_prefix = common.OctopusUrls[in.Platform]
	var reqUrl = url_prefix + l.svcCtx.Config.OctopusApi.GetTrainJob

	token := common.GetToken(in.Platform)

	req := tool.GetACHttpRequest()
	_, err := req.
		SetHeader("Authorization", "Bearer "+token).
		SetPathParam("id", in.Id).
		SetResult(resp).
		Get(reqUrl)

	if err != nil {
		return nil, err
	}

	return resp, nil
}
