package logic

import (
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/common"
	"PCM/common/tool"
	"context"
	"strconv"

	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/svc"
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/octopus"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetTrainJobMetricLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewGetTrainJobMetricLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetTrainJobMetricLogic {
	return &GetTrainJobMetricLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *GetTrainJobMetricLogic) GetTrainJobMetric(in *octopus.GetTrainJobMetricReq) (*octopus.GetTrainJobMetricResp, error) {
	resp := &octopus.GetTrainJobMetricResp{}

	var url_prefix = common.OctopusUrls[in.Platform]
	var reqUrl = url_prefix + l.svcCtx.Config.OctopusApi.GetTrainJobMetric

	token := common.GetToken(in.Platform)

	req := tool.GetACHttpRequest()
	_, err := req.
		SetHeader("Authorization", "Bearer "+token).
		SetQueryString("id=" + in.Id).
		SetQueryString("start=" + strconv.Itoa(int(in.Start))).
		SetQueryString("size=" + strconv.Itoa(int(in.Size))).
		SetQueryString("step=" + strconv.Itoa(int(in.Step))).
		SetResult(resp).
		Get(reqUrl)

	if err != nil {
		return nil, err
	}

	return resp, nil
}
