package logic

import (
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/common"
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/svc"
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/octopus"
	"PCM/common/tool"
	"context"
	"strconv"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetUserImageListLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewGetUserImageListLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetUserImageListLogic {
	return &GetUserImageListLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// ImageService
func (l *GetUserImageListLogic) GetUserImageList(in *octopus.GetUserImageListReq) (*octopus.GetUserImageListResp, error) {
	resp := &octopus.GetUserImageListResp{}

	var url_prefix = common.OctopusUrls[in.Platform]
	var reqUrl = url_prefix + l.svcCtx.Config.OctopusApi.GetUserImageList

	token := common.GetToken(in.Platform)

	req := tool.GetACHttpRequest()
	_, err := req.
		SetHeader("Authorization", "Bearer "+token).
		SetQueryString("pageIndex=" + strconv.Itoa(int(in.PageIndex))).
		SetQueryString("pageSize=" + strconv.Itoa(int(in.PageSize))).
		SetResult(resp).
		Get(reqUrl)

	if err != nil {
		return nil, err
	}

	return resp, nil
}
