package logic

import (
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/common"
	"PCM/common/tool"
	"context"

	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/svc"
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/octopus"

	"github.com/zeromicro/go-zero/core/logx"
)

type InferModelDeployLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewInferModelDeployLogic(ctx context.Context, svcCtx *svc.ServiceContext) *InferModelDeployLogic {
	return &InferModelDeployLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *InferModelDeployLogic) InferModelDeploy(in *octopus.InferModelDeployReq) (*octopus.InferModelDeployResp, error) {
	resp := &octopus.InferModelDeployResp{}

	var url_prefix = common.OctopusUrls[in.Platform]
	var reqUrl = url_prefix + l.svcCtx.Config.OctopusApi.InferModelDeploy

	token := common.GetToken(in.Platform)

	req := tool.GetACHttpRequest()
	_, err := req.
		SetHeader("Authorization", "Bearer "+token).
		SetResult(resp).
		Post(reqUrl)

	if err != nil {
		return nil, err
	}

	return resp, nil
}
