package logic

import (
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/common"
	"PCM/common/tool"
	"context"

	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/svc"
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/octopus"

	"github.com/zeromicro/go-zero/core/logx"
)

type StopModelDeployLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewStopModelDeployLogic(ctx context.Context, svcCtx *svc.ServiceContext) *StopModelDeployLogic {
	return &StopModelDeployLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *StopModelDeployLogic) StopModelDeploy(in *octopus.StopModelDeployReq) (*octopus.StopModelDeployResp, error) {
	resp := &octopus.StopModelDeployResp{}

	var url_prefix = common.OctopusUrls[in.Platform]
	var reqUrl = url_prefix + l.svcCtx.Config.OctopusApi.StopModelDeploy

	token := common.GetToken(in.Platform)

	req := tool.GetACHttpRequest()
	_, err := req.
		SetHeader("Authorization", "Bearer "+token).
		SetPathParam("id", in.Id).
		SetBody("{}").
		SetResult(resp).
		Post(reqUrl)

	if err != nil {
		return nil, err
	}

	return resp, nil
}
