package logic

import (
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/common"
	"PCM/common/tool"
	"context"

	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/svc"
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/octopus"

	"github.com/zeromicro/go-zero/core/logx"
)

type UploadAlgorithmConfirmLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewUploadAlgorithmConfirmLogic(ctx context.Context, svcCtx *svc.ServiceContext) *UploadAlgorithmConfirmLogic {
	return &UploadAlgorithmConfirmLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *UploadAlgorithmConfirmLogic) UploadAlgorithmConfirm(in *octopus.UploadAlgorithmConfirmReq) (*octopus.UploadAlgorithmConfirmResp, error) {
	resp := &octopus.UploadAlgorithmConfirmResp{}

	var url_prefix = common.OctopusUrls[in.Platform]
	var reqUrl = url_prefix + l.svcCtx.Config.OctopusApi.UploadAlgorithmConfirm

	token := common.GetToken(in.Platform)

	req := tool.GetACHttpRequest()
	_, err := req.
		SetHeader("Authorization", "Bearer "+token).
		SetPathParam("algorithmId", in.AlgorithmId).
		SetPathParam("version", in.Version).
		SetBody(in.Params).
		SetResult(resp).
		Put(reqUrl)

	if err != nil {
		return nil, err
	}
	return resp, nil
}
