package logic

import (
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/common"
	"PCM/common/tool"
	"context"

	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/svc"
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/octopus"

	"github.com/zeromicro/go-zero/core/logx"
)

type UploadDataSetConfirmLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewUploadDataSetConfirmLogic(ctx context.Context, svcCtx *svc.ServiceContext) *UploadDataSetConfirmLogic {
	return &UploadDataSetConfirmLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *UploadDataSetConfirmLogic) UploadDataSetConfirm(in *octopus.UploadDataSetConfirmReq) (*octopus.UploadDataSetConfirmResp, error) {
	resp := &octopus.UploadDataSetConfirmResp{}

	var url_prefix = common.OctopusUrls[in.Platform]
	var reqUrl = url_prefix + l.svcCtx.Config.OctopusApi.UploadDataSetConfirm

	token := common.GetToken(in.Platform)

	req := tool.GetACHttpRequest()
	_, err := req.
		SetHeader("Authorization", "Bearer "+token).
		SetPathParam("datasetId", in.DatasetId).
		SetPathParam("version", in.Version).
		SetBody(in.Params).
		SetResult(resp).
		Put(reqUrl)

	if err != nil {
		return nil, err
	}
	return resp, nil
}
