package logic

import (
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/common"
	"PCM/common/tool"
	"context"

	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/svc"
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/octopus"

	"github.com/zeromicro/go-zero/core/logx"
)

type UploadImageConfirmLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewUploadImageConfirmLogic(ctx context.Context, svcCtx *svc.ServiceContext) *UploadImageConfirmLogic {
	return &UploadImageConfirmLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *UploadImageConfirmLogic) UploadImageConfirm(in *octopus.UploadImageConfirmReq) (*octopus.UploadImageConfirmResp, error) {
	resp := &octopus.UploadImageConfirmResp{}

	var url_prefix = common.OctopusUrls[in.Platform]
	var reqUrl = url_prefix + l.svcCtx.Config.OctopusApi.UploadImageConfirm

	token := common.GetToken(in.Platform)

	req := tool.GetACHttpRequest()
	_, err := req.
		SetHeader("Authorization", "Bearer "+token).
		SetPathParam("imageId", in.ImageId).
		SetResult(resp).
		Put(reqUrl)

	if err != nil {
		return nil, err
	}
	return resp, nil
}
