package main

import (
	"PCM/common/interceptor/rpcserver"
	"flag"
	"github.com/zeromicro/go-zero/core/logx"

	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/config"
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/server"
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/internal/svc"
	"PCM/adaptor/PCM-AI/PCM-OCTOPUS/rpc/octopus"

	"github.com/zeromicro/go-zero/core/service"
	"github.com/zeromicro/go-zero/zrpc"
	"google.golang.org/grpc"
	"google.golang.org/grpc/reflection"
)

func main() {
	flag.Parse()

	c := config.Cfg
	ctx := svc.NewServiceContext(c)

	s := zrpc.MustNewServer(c.RpcServerConf, func(grpcServer *grpc.Server) {
		octopus.RegisterOctopusServer(grpcServer, server.NewOctopusServer(ctx))

		if c.Mode == service.DevMode || c.Mode == service.TestMode {
			reflection.Register(grpcServer)
		}
	})

	//rpc log
	s.AddUnaryInterceptors(rpcserver.LoggerInterceptor)

	defer s.Stop()
	logx.Infof("Starting rpc server at %s...\n", c.ListenOn)
	s.Start()

}
