package config

import (
	"github.com/zeromicro/go-queue/kq"
	"github.com/zeromicro/go-zero/core/logx"
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/redis"
	"github.com/zeromicro/go-zero/rest"
	"github.com/zeromicro/go-zero/zrpc"
)

type Config struct {
	rest.RestConf
	KqProducerConf struct {
		Brokers    []string
		HpcTopic   string
		CloudTopic string
		AiTopic    string
	}
	DB struct {
		DataSource string
	}
	Redis             redis.RedisConf
	Cache             cache.CacheConf
	LogConf           logx.LogConf
	HpcConsumerConf   kq.KqConf
	CloudConsumerConf kq.KqConf
	AiConsumerConf    kq.KqConf
	K8sNativeConf     zrpc.RpcClientConf
	ACRpcConf         zrpc.RpcClientConf
	THRpcConf         zrpc.RpcClientConf
	ModelArtsRpcConf  zrpc.RpcClientConf
	CephRpcConf       zrpc.RpcClientConf
	OctopusRpcConf    zrpc.RpcClientConf
	NexusUrl          string
}
