package ai

import (
	"net/http"

	"PCM/adaptor/PCM-CORE/api/internal/logic/ai"
	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"PCM/adaptor/PCM-CORE/api/internal/types"
	"github.com/zeromicro/go-zero/rest/httpx"
)

func GetExportTaskStatusOfDatasetHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.GetExportTaskStatusOfDatasetReq
		if err := httpx.Parse(r, &req); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := ai.NewGetExportTaskStatusOfDatasetLogic(r.Context(), svcCtx)
		resp, err := l.GetExportTaskStatusOfDataset(&req)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
