package core

import (
	"net/http"

	"PCM/adaptor/PCM-CORE/api/internal/logic/core"
	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"github.com/zeromicro/go-zero/rest/httpx"
)

func GetComputingPowerHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		l := core.NewGetComputingPowerLogic(r.Context(), svcCtx)
		resp, err := l.GetComputingPower()
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
