package core

import (
	"net/http"

	"PCM/common/result"

	"PCM/adaptor/PCM-CORE/api/internal/logic/core"
	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"PCM/adaptor/PCM-CORE/api/internal/types"
	"github.com/zeromicro/go-zero/rest/httpx"
)

func PutResourcePanelConfigHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.ResourcePanelConfigReq
		if err := httpx.Parse(r, &req); err != nil {
			result.ParamErrorResult(r, w, err)
			return
		}

		l := core.NewPutResourcePanelConfigLogic(r.Context(), svcCtx)
		err := l.PutResourcePanelConfig(&req)
		result.HttpResult(r, w, nil, err)
	}
}
