package core

import (
	"PCM/common/result"
	"PCM/common/tool"
	"net/http"

	"PCM/adaptor/PCM-CORE/api/internal/logic/core"
	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"PCM/adaptor/PCM-CORE/api/internal/types"
	"github.com/zeromicro/go-zero/rest/httpx"
)

func ScheduleTaskByYamlHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.ScheduleTaskByYamlReq
		if err := httpx.Parse(r, &req); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}
		// 解析yaml文件
		_, fileHeader, err := r.FormFile("file")
		if err != nil {
			result.HttpResult(r, w, nil, err)
			return
		}
		err = tool.Yaml2struct(fileHeader, &req)
		if err != nil {
			result.HttpResult(r, w, nil, err)
			return
		}
		l := core.NewScheduleTaskByYamlLogic(r.Context(), svcCtx)
		err = l.ScheduleTaskByYaml(&req)
		result.HttpResult(r, w, nil, err)
	}
}
