package core

import (
	"PCM/common/result"
	"github.com/zeromicro/go-zero/rest/httpx"
	"io/ioutil"
	"k8s.io/apimachinery/pkg/util/json"
	"net/http"

	"PCM/adaptor/PCM-CORE/api/internal/logic/core"
	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"PCM/adaptor/PCM-CORE/api/internal/types"
)

func ScheduleTaskHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.ScheduleTaskReq
		bytes, err := ioutil.ReadAll(r.Body)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}
		json.Unmarshal(bytes, &req)
		l := core.NewScheduleTaskLogic(r.Context(), svcCtx)
		err = l.ScheduleTask(&req)
		result.HttpResult(r, w, nil, err)
	}
}
