package core

import (
	"PCM/common/result"
	"net/http"

	"PCM/adaptor/PCM-CORE/api/internal/logic/core"
	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"PCM/adaptor/PCM-CORE/api/internal/types"
	"github.com/zeromicro/go-zero/rest/httpx"
)

func SubmitJobHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.ScheduleTaskReq
		if err := httpx.Parse(r, &req); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}
		l := core.NewScheduleTaskLogic(r.Context(), svcCtx)
		err := l.ScheduleTask(&req)
		result.HttpResult(r, w, nil, err)
	}
}
