package image

import (
	result2 "PCM/common/result"
	"net/http"

	"PCM/adaptor/PCM-CORE/api/internal/logic/image"
	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"PCM/adaptor/PCM-CORE/api/internal/types"
	"github.com/zeromicro/go-zero/rest/httpx"
)

func DataSetCheckHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.CheckReq
		if err := httpx.Parse(r, &req); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := image.NewDataSetCheckLogic(r.Context(), svcCtx)
		resp, err := l.DataSetCheck(&req)
		result2.HttpResult(r, w, resp, err)
	}
}
