package ai

import (
	"PCM/adaptor/PCM-AI/PCM-MODELARTS/rpc/modelarts"
	"PCM/common/tool"
	"PCM/common/xerr"
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"

	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"PCM/adaptor/PCM-CORE/api/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type CreateProcessorTaskLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewCreateProcessorTaskLogic(ctx context.Context, svcCtx *svc.ServiceContext) *CreateProcessorTaskLogic {
	return &CreateProcessorTaskLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *CreateProcessorTaskLogic) CreateProcessorTask(req *types.CreateProcessorTaskReq) (resp *types.CreateProcessorTaskResp, err error) {
	modelartsReq := &modelarts.CreateProcessorTaskReq{}
	err = copier.CopyWithOption(modelartsReq, req, copier.Option{Converters: tool.Converters})
	CreateProcessorTaskResp, err := l.svcCtx.ModelArtsRpc.CreateProcessorTask(l.ctx, modelartsReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("Failed to get db DataSet list"), "Failed to get db DataSet list err : %v ,req:%+v", err, req)
	}
	resp = &types.CreateProcessorTaskResp{}

	err = copier.CopyWithOption(&resp, &CreateProcessorTaskResp, copier.Option{Converters: tool.Converters})

	return resp, nil
}
