package ai

import (
	"PCM/adaptor/PCM-AI/PCM-MODELARTS/rpc/modelarts"
	"PCM/common/result"
	"PCM/common/tool"
	"PCM/common/xerr"
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"k8s.io/apimachinery/pkg/util/json"
	"strings"

	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"PCM/adaptor/PCM-CORE/api/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type DeleteAlgorithmLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewDeleteAlgorithmLogic(ctx context.Context, svcCtx *svc.ServiceContext) *DeleteAlgorithmLogic {
	return &DeleteAlgorithmLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *DeleteAlgorithmLogic) DeleteAlgorithm(req *types.DeleteAlgorithmReq) (resp *types.DeleteAlgorithmResp, err error) {
	modelartsReq := &modelarts.DeleteAlgorithmsReq{}
	reqByte, err := json.Marshal(req)
	if err != nil {
		return nil, err
	}
	payload := strings.NewReader(string(reqByte))
	println(payload)
	err = copier.CopyWithOption(modelartsReq, req, copier.Option{Converters: tool.Converters})
	DeleteAlgorithmResp, err := l.svcCtx.ModelArtsRpc.DeleteAlgorithms(l.ctx, modelartsReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("Failed to get db DataSet list"), "Failed to get db DataSet list err : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&DeleteAlgorithmResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &DeleteAlgorithmResp, copier.Option{Converters: tool.Converters})
	return resp, nil
}
