package ai

import (
	"PCM/adaptor/PCM-AI/PCM-MODELARTS/rpc/modelarts"
	"PCM/common/result"
	"PCM/common/tool"
	"context"
	"github.com/jinzhu/copier"
	"k8s.io/apimachinery/pkg/util/json"

	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"PCM/adaptor/PCM-CORE/api/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetExportTaskStatusOfDatasetLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewGetExportTaskStatusOfDatasetLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetExportTaskStatusOfDatasetLogic {
	return &GetExportTaskStatusOfDatasetLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *GetExportTaskStatusOfDatasetLogic) GetExportTaskStatusOfDataset(req *types.GetExportTaskStatusOfDatasetReq) (resp *types.GetExportTaskStatusOfDatasetResp, err error) {
	modelartsReq := &modelarts.GetExportTaskStatusOfDatasetReq{}
	err = copier.CopyWithOption(modelartsReq, req, copier.Option{IgnoreEmpty: true, DeepCopy: true, Converters: tool.Converters})
	GetExportTaskStatusOfDatasetResp, err := l.svcCtx.ModelArtsRpc.GetExportTaskStatusOfDataset(l.ctx, modelartsReq)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	marshal, err := json.Marshal(&GetExportTaskStatusOfDatasetResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &GetExportTaskStatusOfDatasetResp, copier.Option{Converters: tool.Converters})
	return resp, nil
}
