package ai

import (
	"PCM/adaptor/PCM-AI/PCM-MODELARTS/rpc/modelarts"
	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"PCM/adaptor/PCM-CORE/api/internal/types"
	"PCM/common/result"
	"PCM/common/tool"
	"PCM/common/xerr"
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"k8s.io/apimachinery/pkg/util/json"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetListTrainingJobsLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewGetListTrainingJobsLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetListTrainingJobsLogic {
	return &GetListTrainingJobsLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *GetListTrainingJobsLogic) GetListTrainingJobs(req *types.ListTrainingJobsreq) (resp *types.ListTrainingJobsresp, err error) {
	modelartsReq := &modelarts.ListTrainingJobsreq{}
	err = copier.CopyWithOption(modelartsReq, req, copier.Option{Converters: tool.Converters})
	listDataSetResp, err := l.svcCtx.ModelArtsRpc.GetListTrainingJobs(l.ctx, modelartsReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("Failed to get db DataSet list"), "Failed to get db DataSet list err : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&listDataSetResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &listDataSetResp, copier.Option{Converters: tool.Converters})
	return resp, nil
	/*	modelartsType := req.ModelartsType
		switch modelartsType {
		case "octops":
			octopusReq := &octopus.GetTrainJobListReq{}
			err = copier.CopyWithOption(octopusReq, req, copier.Option{Converters: tool.Converters})
			listTrainJobResp, err := l.svcCtx.OctopusRpc.GetTrainJobList(l.ctx, octopusReq)
			if err != nil {
				return nil, errors.Wrapf(xerr.NewErrMsg("Failed to get db TrainJobs list"), "Failed to get db DataSet list err : %v ,req:%+v", err, req)
			}
			marshal, err := json.Marshal(&listTrainJobResp)
			if err != nil {
				return nil, result.NewDefaultError(err.Error())
			}
			json.Unmarshal(marshal, &resp)
			err = copier.CopyWithOption(&resp, &listTrainJobResp, copier.Option{Converters: tool.Converters})
		case "cn-north-4.myhuawei":
			modelartsReq := &modelarts.ListTrainingJobsreq{}
			err = copier.CopyWithOption(modelartsReq, req, copier.Option{Converters: tool.Converters})
			listDataSetResp, err := l.svcCtx.ModelArtsRpc.GetListTrainingJobs(l.ctx, modelartsReq)
			if err != nil {
				return nil, errors.Wrapf(xerr.NewErrMsg("Failed to get db TrainJobs list"), "Failed to get db DataSet list err : %v ,req:%+v", err, req)
			}
			marshal, err := json.Marshal(&listDataSetResp)
			if err != nil {
				return nil, result.NewDefaultError(err.Error())
			}
			json.Unmarshal(marshal, &resp)
			err = copier.CopyWithOption(&resp, &listDataSetResp, copier.Option{Converters: tool.Converters})
		case "cn-east-293.njaci":
			modelartsReq := &modelarts.ListTrainingJobsreq{}

			err = copier.CopyWithOption(modelartsReq, req, copier.Option{Converters: tool.Converters})
			listDataSetResp, err := l.svcCtx.ModelArtsRpc.GetListTrainingJobs(l.ctx, modelartsReq)
			if err != nil {
				return nil, errors.Wrapf(xerr.NewErrMsg("Failed to get db TrainJobs list"), "Failed to get db DataSet list err : %v ,req:%+v", err, req)
			}
			marshal, err := json.Marshal(&listDataSetResp)
			if err != nil {
				return nil, result.NewDefaultError(err.Error())
			}
			json.Unmarshal(marshal, &resp)
			err = copier.CopyWithOption(&resp, &listDataSetResp, copier.Option{Converters: tool.Converters})
		}*/

}
