package ai

import (
	"PCM/adaptor/PCM-AI/PCM-MODELARTS/rpc/modelarts"
	"PCM/common/result"
	"PCM/common/tool"
	"context"
	"github.com/jinzhu/copier"
	"k8s.io/apimachinery/pkg/util/json"

	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"PCM/adaptor/PCM-CORE/api/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ShowServiceLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewShowServiceLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ShowServiceLogic {
	return &ShowServiceLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ShowServiceLogic) ShowService(req *types.ShowServiceReq) (resp *types.ShowServiceResp, err error) {
	modelartsReq := &modelarts.ShowServiceReq{}
	err = copier.CopyWithOption(modelartsReq, req, copier.Option{Converters: tool.Converters})
	ShowServiceResp, err := l.svcCtx.ModelArtsRpc.ShowService(l.ctx, modelartsReq)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	marshal, err := json.Marshal(&ShowServiceResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &ShowServiceResp, copier.Option{IgnoreEmpty: true, DeepCopy: true, Converters: tool.Converters})
	return resp, nil
}
