package core

import (
	"PCM/adaptor/PCM-CORE/model"
	"context"

	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"PCM/adaptor/PCM-CORE/api/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetRegionLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewGetRegionLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetRegionLogic {
	return &GetRegionLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *GetRegionLogic) GetRegion() (resp *types.GetRegionResp, err error) {
	resp = &types.GetRegionResp{}
	var regionSlurmArray []model.RegionSlurm
	regionNameDb := l.svcCtx.DbEngin.Find(&regionSlurmArray).Not("RegionName = ?", "")
	softStackDb := l.svcCtx.DbEngin.Find(&regionSlurmArray).Not("SoftStack = ?", "")
	resp = &types.GetRegionResp{
		Code: 200,
		Msg:  "Success",
		Data: types.RegionNum{
			RegionSum:    regionNameDb.RowsAffected,
			SoftStackSum: softStackDb.RowsAffected,
		},
	}
	return resp, err
}
