package core

import (
	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"PCM/adaptor/PCM-CORE/api/internal/types"
	"PCM/adaptor/PCM-CORE/model"
	"PCM/common/tool"
	"context"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetResourcePanelConfigLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewGetResourcePanelConfigLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetResourcePanelConfigLogic {
	return &GetResourcePanelConfigLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *GetResourcePanelConfigLogic) GetResourcePanelConfig() (resp *types.ResourcePanelConfigResp, err error) {
	rpcModel := model.ResourcePanelConfig{}
	l.svcCtx.DbEngin.Find(&rpcModel)
	tool.Convert(rpcModel, &resp)
	return resp, nil
}
