package core

import (
	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"PCM/adaptor/PCM-CORE/api/internal/types"
	"PCM/adaptor/PCM-CORE/model"
	"PCM/common/tool"
	"context"
	"math/rand"
	"strconv"
	"time"

	"github.com/zeromicro/go-zero/core/logx"
)

type ListDomainResourceLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewListDomainResourceLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ListDomainResourceLogic {
	return &ListDomainResourceLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ListDomainResourceLogic) ListDomainResource() (resp *types.DomainResourceResp, err error) {

	resp = &types.DomainResourceResp{}
	var domainResourceModel []model.DomainResource
	sqlStr := `select * from domain_resource where delete_flag=0 order by id`
	l.svcCtx.DbEngin.Raw(sqlStr).Scan(&domainResourceModel)
	tool.Convert(domainResourceModel, &resp.DomainResourceList)
	rand.Seed(time.Now().UnixNano())
	//TODO rand
	for i := 0; i < len(resp.DomainResourceList); i++ {
		c := rand.Intn(65) + 10
		m := rand.Intn(65) + 10
		d := rand.Intn(65) + 10
		n := rand.Intn(65) + 10
		resp.DomainResourceList[i].Cpu = strconv.Itoa(c)
		resp.DomainResourceList[i].Memory = strconv.Itoa(m)
		resp.DomainResourceList[i].Disk = strconv.Itoa(d)
		resp.DomainResourceList[i].NodeCount = strconv.Itoa(n)
	}
	return resp, nil
}
