package core

import (
	"PCM/adaptor/PCM-CORE/model"
	"PCM/common/tool"
	"context"

	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"PCM/adaptor/PCM-CORE/api/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ListRegionLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewListRegionLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ListRegionLogic {
	return &ListRegionLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ListRegionLogic) ListRegion() (resp *types.ListRegionResp, err error) {
	// todo: add your logic here and delete this line
	var regionSlurmArray []model.RegionSlurm
	var regions []types.Region
	var jobCount int64
	var regionResult []types.Region
	l.svcCtx.DbEngin.Find(&regionSlurmArray)
	tool.Convert(regionSlurmArray, &regions)
	// 查询超算上的job todo
	for _, region := range regions {
		if region.RegionName == "Changsha HPC Center" {
			l.svcCtx.DbEngin.Raw("select count(*) from task t join hpc h on t.id = h.task_id and t.status != 'Completed' and h.service_name = 'th'").Scan(&jobCount)
			region.RunningJobs = jobCount
		}
		if region.RegionName == "Zhijiang HPC Center" {
			l.svcCtx.DbEngin.Raw("select count(*) from task t join hpc h on t.id = h.task_id and t.status != 'Completed' and h.service_name = 'ac'").Scan(&jobCount)
			region.RunningJobs = jobCount
		}
		regionResult = append(regionResult, region)

	}

	resp = &types.ListRegionResp{
		Code: 200,
		Msg:  "Success",
		Data: regionResult,
	}
	return
}
