package core

import (
	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"PCM/adaptor/PCM-CORE/api/internal/types"
	"PCM/adaptor/PCM-CORE/model"
	"PCM/common/tool"
	"context"
	"time"

	"github.com/zeromicro/go-zero/core/logx"
)

type PutResourcePanelConfigLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewPutResourcePanelConfigLogic(ctx context.Context, svcCtx *svc.ServiceContext) *PutResourcePanelConfigLogic {
	return &PutResourcePanelConfigLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *PutResourcePanelConfigLogic) PutResourcePanelConfig(req *types.ResourcePanelConfigReq) error {
	rpcModel := model.ResourcePanelConfig{}
	tool.Convert(req, &rpcModel)
	rpcModel.UpdateTime = time.Now()

	update := l.svcCtx.DbEngin.Model(&rpcModel).Updates(rpcModel)
	err := update.Error
	if err != nil {
		logx.WithContext(l.ctx).Errorf("PCM 资源面板数据更新失败 err: %s", err.Error())
		return err
	}
	return nil
}
