package image

import (
	"PCM/adaptor/PCM-CORE/model"
	"context"

	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"PCM/adaptor/PCM-CORE/api/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type DataSetCheckLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewDataSetCheckLogic(ctx context.Context, svcCtx *svc.ServiceContext) *DataSetCheckLogic {
	return &DataSetCheckLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *DataSetCheckLogic) DataSetCheck(req *types.CheckReq) (resp *types.CheckResp, err error) {
	resp = &types.CheckResp{}
	var dataSets []model.DataSet
	l.svcCtx.DbEngin.Find(&dataSets).Where("md5", req.FileMd5)
	if len(dataSets) != 0 {
		resp.Exist = true
	} else {
		resp.Exist = false
	}
	return resp, nil
}
