package kq

import (
	"PCM/adaptor/PCM-CORE/api/internal/svc"
	"PCM/adaptor/PCM-CORE/api/internal/types"
	"PCM/adaptor/PCM-CORE/model"
	"PCM/common/tool"
	"context"
	"encoding/json"
	"github.com/zeromicro/go-zero/core/logx"
)

/*
*
Listening to the payment flow status change notification message queue
*/
type ScheduleHpcMq struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewScheduleHpcMq(ctx context.Context, svcCtx *svc.ServiceContext) *ScheduleHpcMq {
	return &ScheduleHpcMq{
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ScheduleHpcMq) Consume(_, val string) error {
	// 接受消息
	var task *types.TaskInfo
	json.Unmarshal([]byte(val), &task)
	hpc := model.Hpc{
		TaskId:      task.TaskId,
		Status:      "Saved",
		ServiceName: task.ServiceName,
		YamlString:  val,
	}
	tool.Convert(task.Metadata, &hpc)
	// 存储数据
	tx := l.svcCtx.DbEngin.Create(&hpc)
	if tx.Error != nil {
		logx.Error(tx.Error)
		return tx.Error
	}
	return nil
}
