package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AiCenterModel = (*customAiCenterModel)(nil)

type (
	// AiCenterModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAiCenterModel.
	AiCenterModel interface {
		aiCenterModel
	}

	customAiCenterModel struct {
		*defaultAiCenterModel
	}
)

// NewAiCenterModel returns a model for the database table.
func NewAiCenterModel(conn sqlx.SqlConn, c cache.CacheConf) AiCenterModel {
	return &customAiCenterModel{
		defaultAiCenterModel: newAiCenterModel(conn, c),
	}
}
