package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AiModel = (*customAiModel)(nil)

type (
	// AiModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAiModel.
	AiModel interface {
		aiModel
	}

	customAiModel struct {
		*defaultAiModel
	}
)

// NewAiModel returns a model for the database table.
func NewAiModel(conn sqlx.SqlConn, c cache.CacheConf) AiModel {
	return &customAiModel{
		defaultAiModel: newAiModel(conn),
	}
}
