package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ CenterOverviewModel = (*customCenterOverviewModel)(nil)

type (
	// CenterOverviewModel is an interface to be customized, add more methods here,
	// and implement the added methods in customCenterOverviewModel.
	CenterOverviewModel interface {
		centerOverviewModel
	}

	customCenterOverviewModel struct {
		*defaultCenterOverviewModel
	}
)

// NewCenterOverviewModel returns a model for the database table.
func NewCenterOverviewModel(conn sqlx.SqlConn, c cache.CacheConf) CenterOverviewModel {
	return &customCenterOverviewModel{
		defaultCenterOverviewModel: newCenterOverviewModel(conn, c),
	}
}
