package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ CenterTagModel = (*customCenterTagModel)(nil)

type (
	// CenterTagModel is an interface to be customized, add more methods here,
	// and implement the added methods in customCenterTagModel.
	CenterTagModel interface {
		centerTagModel
	}

	customCenterTagModel struct {
		*defaultCenterTagModel
	}
)

// NewCenterTagModel returns a model for the database table.
func NewCenterTagModel(conn sqlx.SqlConn, c cache.CacheConf) CenterTagModel {
	return &customCenterTagModel{
		defaultCenterTagModel: newCenterTagModel(conn, c),
	}
}
