package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ CloudCenterModel = (*customCloudCenterModel)(nil)

type (
	// CloudCenterModel is an interface to be customized, add more methods here,
	// and implement the added methods in customCloudCenterModel.
	CloudCenterModel interface {
		cloudCenterModel
	}

	customCloudCenterModel struct {
		*defaultCloudCenterModel
	}
)

// NewCloudCenterModel returns a model for the database table.
func NewCloudCenterModel(conn sqlx.SqlConn, c cache.CacheConf) CloudCenterModel {
	return &customCloudCenterModel{
		defaultCloudCenterModel: newCloudCenterModel(conn, c),
	}
}
