package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ CloudModel = (*customCloudModel)(nil)

type (
	// CloudModel is an interface to be customized, add more methods here,
	// and implement the added methods in customCloudModel.
	CloudModel interface {
		cloudModel
	}

	customCloudModel struct {
		*defaultCloudModel
	}
)

// NewCloudModel returns a model for the database table.
func NewCloudModel(conn sqlx.SqlConn, c cache.CacheConf) CloudModel {
	return &customCloudModel{
		defaultCloudModel: newCloudModel(conn),
	}
}
