package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ ComputeCenterModel = (*customComputeCenterModel)(nil)

type (
	// ComputeCenterModel is an interface to be customized, add more methods here,
	// and implement the added methods in customComputeCenterModel.
	ComputeCenterModel interface {
		computeCenterModel
	}

	customComputeCenterModel struct {
		*defaultComputeCenterModel
	}
)

// NewComputeCenterModel returns a model for the database table.
func NewComputeCenterModel(conn sqlx.SqlConn, c cache.CacheConf) ComputeCenterModel {
	return &customComputeCenterModel{
		defaultComputeCenterModel: newComputeCenterModel(conn, c),
	}
}
