package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ DomainResourceModel = (*customDomainResourceModel)(nil)

type (
	// DomainResourceModel is an interface to be customized, add more methods here,
	// and implement the added methods in customDomainResourceModel.
	DomainResourceModel interface {
		domainResourceModel
	}

	customDomainResourceModel struct {
		*defaultDomainResourceModel
	}
)

// NewDomainResourceModel returns a model for the database table.
func NewDomainResourceModel(conn sqlx.SqlConn, c cache.CacheConf, opts ...cache.Option) DomainResourceModel {
	return &customDomainResourceModel{
		defaultDomainResourceModel: newDomainResourceModel(conn, c, opts...),
	}
}
