package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ HpcCenterModel = (*customHpcCenterModel)(nil)

type (
	// HpcCenterModel is an interface to be customized, add more methods here,
	// and implement the added methods in customHpcCenterModel.
	HpcCenterModel interface {
		hpcCenterModel
	}

	customHpcCenterModel struct {
		*defaultHpcCenterModel
	}
)

// NewHpcCenterModel returns a model for the database table.
func NewHpcCenterModel(conn sqlx.SqlConn, c cache.CacheConf) HpcCenterModel {
	return &customHpcCenterModel{
		defaultHpcCenterModel: newHpcCenterModel(conn, c),
	}
}
