package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ HpcModel = (*customHpcModel)(nil)

type (
	// HpcModel is an interface to be customized, add more methods here,
	// and implement the added methods in customHpcModel.
	HpcModel interface {
		hpcModel
	}

	customHpcModel struct {
		*defaultHpcModel
	}
)

// NewHpcModel returns a model for the database table.
func NewHpcModel(conn sqlx.SqlConn, c cache.CacheConf) HpcModel {
	return &customHpcModel{
		defaultHpcModel: newHpcModel(conn),
	}
}
