package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ ResourcePanelConfigModel = (*customResourcePanelConfigModel)(nil)

type (
	// ResourcePanelConfigModel is an interface to be customized, add more methods here,
	// and implement the added methods in customResourcePanelConfigModel.
	ResourcePanelConfigModel interface {
		resourcePanelConfigModel
	}

	customResourcePanelConfigModel struct {
		*defaultResourcePanelConfigModel
	}
)

// NewResourcePanelConfigModel returns a model for the database table.
func NewResourcePanelConfigModel(conn sqlx.SqlConn, c cache.CacheConf, opts ...cache.Option) ResourcePanelConfigModel {
	return &customResourcePanelConfigModel{
		defaultResourcePanelConfigModel: newResourcePanelConfigModel(conn, c, opts...),
	}
}
