package svc

import (
	"PCM/adaptor/PCM-CORE/rpc/internal/config"
	_ "github.com/go-sql-driver/mysql"
	"github.com/robfig/cron/v3"
	"gorm.io/driver/mysql"
	"gorm.io/gorm"
	"gorm.io/gorm/logger"
	"gorm.io/gorm/schema"
)

type ServiceContext struct {
	Config  config.Config
	DbEngin *gorm.DB
	Cron    *cron.Cron
}

func NewServiceContext(c config.Config) *ServiceContext {
	//启动Gorm支持
	dbEngin, _ := gorm.Open(mysql.Open(c.DB.DataSource), &gorm.Config{
		NamingStrategy: schema.NamingStrategy{
			SingularTable: true, // 使用单数表名，启用该选项，此时，`User` 的表名应该是 `t_user`
		},
		Logger: logger.Default.LogMode(logger.Info),
	})
	return &ServiceContext{
		Cron:    cron.New(cron.WithSeconds()),
		Config:  c,
		DbEngin: dbEngin,
	}
}
