package common

type CenterResp struct {
	Code string `json:"code"`
	Msg  string `json:"msg"`
	Data struct {
		Id          int           `json:"id"`
		Name        string        `json:"name"`
		Description string        `json:"description"`
		IngressUrls []interface{} `json:"ingressUrls"`
		EfileUrls   []struct {
			NodeName        string `json:"nodeName"`
			Enable          string `json:"enable"`
			FastTransEnable string `json:"fastTransEnable"`
			UdpPort         string `json:"udpPort"`
			Version         string `json:"version"`
			Url             string `json:"url"`
			AppId           string `json:"appId,omitempty"`
			AppSecret       string `json:"appSecret,omitempty"`
			IsManagerNode   string `json:"isManagerNode,omitempty"`
		} `json:"efileUrls"`
		EshellUrls []struct {
			Enable          string `json:"enable"`
			Version         string `json:"version"`
			Url             string `json:"url"`
			NodeName        string `json:"nodeName,omitempty"`
			AppId           string `json:"appId,omitempty"`
			AppSecret       string `json:"appSecret,omitempty"`
			FastTransEnable string `json:"fastTransEnable,omitempty"`
			UdpPort         string `json:"udpPort,omitempty"`
			IsManagerNode   string `json:"isManagerNode,omitempty"`
		} `json:"eshellUrls"`
		HpcUrls []struct {
			Enable        string `json:"enable"`
			IsManagerNode string `json:"isManagerNode"`
			Version       string `json:"version"`
			Url           string `json:"url"`
		} `json:"hpcUrls"`
		AiUrls []struct {
			Enable  string `json:"enable"`
			Version string `json:"version"`
			Url     string `json:"url"`
		} `json:"aiUrls"`
		EshellSshHosts []struct {
			Enable          string `json:"enable"`
			Url             string `json:"url"`
			NodeName        string `json:"nodeName,omitempty"`
			AppId           string `json:"appId,omitempty"`
			AppSecret       string `json:"appSecret,omitempty"`
			FastTransEnable string `json:"fastTransEnable,omitempty"`
			UdpPort         string `json:"udpPort,omitempty"`
			IsManagerNode   string `json:"isManagerNode,omitempty"`
			Version         string `json:"version,omitempty"`
		} `json:"eshellSshHosts"`
		InternetSshHosts []struct {
			LimitState string `json:"limitState"`
			Url        string `json:"url"`
		} `json:"internetSshHosts"`
		ClusterUserInfo struct {
			UserName string `json:"userName"`
			HomePath string `json:"homePath"`
		} `json:"clusterUserInfo"`
	} `json:"data"`
}

type TokenResp struct {
	Code string `json:"code"`
	Msg  string `json:"msg"`
	Data []struct {
		ClusterId   string `json:"clusterId"`
		ClusterName string `json:"clusterName"`
		Token       string `json:"token"`
	} `json:"data"`
}

type QuotaResp struct {
	Code string `json:"code"`
	Msg  string `json:"msg"`
	Data struct {
		UserName            interface{} `json:"userName"`
		AccountName         interface{} `json:"accountName"`
		UserMaxCpu          int         `json:"userMaxCpu"`
		UserMaxDcu          int         `json:"userMaxDcu"`
		UserMaxGpu          int         `json:"userMaxGpu"`
		UserMaxMlu          int         `json:"userMaxMlu"`
		UserMaxMem          int         `json:"userMaxMem"`
		UserMaxNode         int         `json:"userMaxNode"`
		UserMaxSubmitJob    int         `json:"userMaxSubmitJob"`
		UserMaxRunJob       int         `json:"userMaxRunJob"`
		AccountMaxCpu       int         `json:"accountMaxCpu"`
		AccountMaxDcu       int         `json:"accountMaxDcu"`
		AccountMaxGpu       int         `json:"accountMaxGpu"`
		AccountMaxMlu       int         `json:"accountMaxMlu"`
		AccountMaxMem       int         `json:"accountMaxMem"`
		AccountMaxNode      int         `json:"accountMaxNode"`
		AccountMaxSubmitJob int         `json:"accountMaxSubmitJob"`
		AccountMaxRunJob    int         `json:"accountMaxRunJob"`
		UserMinCpu          int         `json:"userMinCpu"`
		UserMinNode         int         `json:"userMinNode"`
		MaxWallTime         int         `json:"maxWallTime"`
	} `json:"data"`
}

type ClusterResp struct {
	Code string `json:"code"`
	Msg  string `json:"msg"`
	Data []struct {
		JobManagerAddr string `json:"JobManagerAddr"`
		JobManagerType string `json:"JobManagerType"`
		Id             int    `json:"id"`
		Text           string `json:"text"`
		JobManagerPort string `json:"JobManagerPort"`
	} `json:"data"`
}
type ResourceGroupResp struct {
	Code string `json:"code"`
	Msg  string `json:"msg"`
	Data struct {
		Dcu []string `json:"dcu"`
		Cpu []string `json:"cpu"`
	} `json:"data"`
}

type ParastorQuota struct {
	Code string `json:"code"`
	Msg  string `json:"msg"`
	Data []struct {
		Username  interface{} `json:"username"`
		Path      string      `json:"path"`
		Threshold int         `json:"threshold"`
		Usage     float64     `json:"usage"`
	} `json:"data"`
}

type ResourceResp struct {
	Code string `json:"code"`
	Msg  string `json:"msg"`
	Data struct {
		Id            interface{} `json:"id"`
		CpuNumber     int         `json:"cpuNumber"`
		MluLimits     int         `json:"mluLimits"`
		DcuLimits     int         `json:"dcuLimits"`
		NvLimits      int         `json:"nvLimits"`
		GpuNumber     int         `json:"gpuNumber"`
		MemorySize    int         `json:"memorySize"`
		ResourceGroup string      `json:"resourceGroup"`
		UserName      interface{} `json:"userName"`
		NodeNumber    int         `json:"nodeNumber"`
		MaxTime       string      `json:"maxTime"`
	} `json:"data"`
}
