package logic

import (
	"PCM/common/tool"
	"context"

	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/hpcAC"
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/internal/svc"

	"github.com/zeromicro/go-zero/core/logx"
)

type CpuCoreLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewCpuCoreLogic(ctx context.Context, svcCtx *svc.ServiceContext) *CpuCoreLogic {
	return &CpuCoreLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *CpuCoreLogic) CpuCore(in *hpcAC.CpuCoreReq) (*hpcAC.CpuCoreResp, error) {

	getTokenLogic := NewGetACTokenLogic(l.ctx, l.svcCtx)
	tokenResp, _ := getTokenLogic.GetACToken(&hpcAC.ACTokenReq{})
	token := tokenResp.GetData().Token

	url := "https://api01.hpccube.com:65106/hpc/openapi/v2/view/cpucore/state"
	var cpuCoreResp *hpcAC.CpuCoreResp
	acHttpRequest := tool.GetACHttpRequest()
	acHttpRequest.SetHeader(tool.ContentType, tool.ApplicationJson).
		SetResult(&cpuCoreResp).
		SetHeader("token", token).
		Get(url)
	return cpuCoreResp, nil
}
