package logic

import (
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/hpcAC"
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/internal/svc"
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/internal/util"
	"PCM/common/tool"
	"context"
	"strconv"

	"github.com/zeromicro/go-zero/core/logx"
)

type FileContentLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewFileContentLogic(ctx context.Context, svcCtx *svc.ServiceContext) *FileContentLogic {
	return &FileContentLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// FileContent 查看文件内容
func (l *FileContentLogic) FileContent(in *hpcAC.FileDataReq) (*hpcAC.FileContentResp, error) {
	var resp hpcAC.FileContentResp
	url := "/hpc/openapi/v2/file/content"
	triggerNum := strconv.FormatInt(int64(in.TriggerNum), 10)
	queryParams := map[string]string{
		"hostName":      in.HostName,
		"dirPath":       in.DirPath,
		"triggerNum":    triggerNum,
		"rollDirection": in.RollDirection,
	}
	_, _ = util.Post("", l.svcCtx.Config.ClusterUrl, url, tool.ApplicationFromUrlencoded, nil, nil, nil, nil, &queryParams, &resp)
	return &resp, nil
}
