package logic

import (
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/hpcAC"
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/internal/svc"
	"PCM/common/tool"
	"context"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetJobDetailLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewGetJobDetailLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetJobDetailLogic {
	return &GetJobDetailLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// GetJobDetail get job detail
func (l *GetJobDetailLogic) GetJobDetail(in *hpcAC.JobDetailReq) (*hpcAC.GetJobDetailResp, error) {

	getTokenLogic := NewGetACTokenLogic(l.ctx, l.svcCtx)
	tokenResp, _ := getTokenLogic.GetACToken(&hpcAC.ACTokenReq{})
	token := tokenResp.GetData().Token

	var resp *hpcAC.GetJobDetailResp
	acHttpRequest := tool.GetACHttpRequest()
	acHttpRequest.SetHeader(tool.ContentType, tool.ApplicationJson).
		SetResult(&resp).
		SetHeader("token", token).
		Get("https://api01.hpccube.com:65106/hpc/openapi/v2/jobs/" + in.JobId)

	return resp, nil
}
