package logic

import (
	"PCM/common/tool"
	"context"
	"fmt"

	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/hpcAC"
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/internal/svc"

	"github.com/zeromicro/go-zero/core/logx"
)

type HistoryJobDetailLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewHistoryJobDetailLogic(ctx context.Context, svcCtx *svc.ServiceContext) *HistoryJobDetailLogic {
	return &HistoryJobDetailLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *HistoryJobDetailLogic) HistoryJobDetail(in *hpcAC.HistoryJobDetailReq) (*hpcAC.HistoryJobDetailResp, error) {

	getTokenLogic := NewGetACTokenLogic(l.ctx, l.svcCtx)
	tokenResp, _ := getTokenLogic.GetACToken(&hpcAC.ACTokenReq{})
	token := tokenResp.GetData().Token

	var url string
	if in.AcctTime != "" {
		url = fmt.Sprintf("https://api01.hpccube.com:65106/hpc/openapi/v2/historyjobs/%s/%s?acctTime=%s", in.JobmanagerId, in.JobId, in.AcctTime)
	} else {
		url = fmt.Sprintf("https://api01.hpccube.com:65106/hpc/openapi/v2/historyjobs/%s/%s", in.JobmanagerId, in.JobId)
	}

	var historyJobDetail *hpcAC.HistoryJobDetailResp
	acHttpRequest := tool.GetACHttpRequest()
	acHttpRequest.SetHeader(tool.ContentType, tool.ApplicationJson).
		SetResult(&historyJobDetail).
		SetHeader("token", token).
		Get(url)

	return historyJobDetail, nil
}
