package logic

import (
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/hpcAC"
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/internal/svc"
	"PCM/common/tool"
	"context"

	"github.com/zeromicro/go-zero/core/logx"
)

type JobsLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewJobsLogic(ctx context.Context, svcCtx *svc.ServiceContext) *JobsLogic {
	return &JobsLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *JobsLogic) Jobs(in *hpcAC.JobsReq) (*hpcAC.JobsResp, error) {

	getTokenLogic := NewGetACTokenLogic(l.ctx, l.svcCtx)
	tokenResp, _ := getTokenLogic.GetACToken(&hpcAC.ACTokenReq{})
	token := tokenResp.GetData().Token

	url := "https://api01.hpccube.com:65106/hpc/openapi/v2/view/jobs/state?userName=" + in.UserName
	var jobsResp *hpcAC.JobsResp
	acHttpRequest := tool.GetACHttpRequest()
	acHttpRequest.SetHeader(tool.ContentType, tool.ApplicationJson).
		SetResult(&jobsResp).
		SetHeader("token", token).
		Get(url)
	return jobsResp, nil
}
