package logic

import (
	"PCM/common/tool"
	"context"

	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/hpcAC"
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/internal/svc"

	"github.com/zeromicro/go-zero/core/logx"
)

type ParaStorQuotaLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewParaStorQuotaLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ParaStorQuotaLogic {
	return &ParaStorQuotaLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// ParaStor Quota
func (l *ParaStorQuotaLogic) ParaStorQuota(in *hpcAC.ParaStorQuotaReq) (*hpcAC.ParaStorQuotaResp, error) {

	getTokenLogic := NewGetACTokenLogic(l.ctx, l.svcCtx)
	tokenResp, _ := getTokenLogic.GetACToken(&hpcAC.ACTokenReq{})
	token := tokenResp.GetData().Token

	url := "https://api01.hpccube.com:65106/hpc/openapi/v2/parastor/quota/usernames/" + in.Username
	var acResp *hpcAC.ParaStorQuotaResp
	acHttpRequest := tool.GetACHttpRequest()
	acHttpRequest.SetHeader(tool.ContentType, tool.ApplicationJson).
		SetResult(&acResp).
		SetHeader("token", token).
		Get(url)
	return acResp, nil
}
