package logic

import (
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/hpcAC"
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/internal/svc"
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/internal/util"
	"context"
	"fmt"

	"github.com/zeromicro/go-zero/core/logx"
)

type QueryQueueDetailsLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewQueryQueueDetailsLogic(ctx context.Context, svcCtx *svc.ServiceContext) *QueryQueueDetailsLogic {
	return &QueryQueueDetailsLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// QueryQueueDetails 查询队列资源详细信息
func (l *QueryQueueDetailsLogic) QueryQueueDetails(in *hpcAC.QueueReq) (*hpcAC.QueueDetailsResp, error) {
	resp := hpcAC.QueueDetailsResp{}
	url := fmt.Sprintf("/hpc/openapi/v2/userquotas/queues?strJobManagerID=%s", in.StrJobManagerID)
	_, _ = util.Get("", l.svcCtx.Config.ClusterUrl, url, nil, nil, &resp)

	return &resp, nil
}
