package logic

import (
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/internal/util"
	"context"
	"fmt"

	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/hpcAC"
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/internal/svc"

	"github.com/zeromicro/go-zero/core/logx"
)

type QueryUserQuotasLimitLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewQueryUserQuotasLimitLogic(ctx context.Context, svcCtx *svc.ServiceContext) *QueryUserQuotasLimitLogic {
	return &QueryUserQuotasLimitLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// QueryUserQuotasLimit 查询用户资源限制信息
func (l *QueryUserQuotasLimitLogic) QueryUserQuotasLimit(in *hpcAC.QueueReq) (*hpcAC.UserQuotasLimitResp, error) {
	resp := hpcAC.UserQuotasLimitResp{}
	url := fmt.Sprintf("hpc/openapi/v2/userquotas/userlimit?strJobManagerID=%s", in.StrJobManagerID)
	_, _ = util.Get("", l.svcCtx.Config.ClusterUrl, url, nil, nil, &resp)

	return &resp, nil
}
