package logic

import (
	"PCM/common/tool"
	"context"

	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/hpcAC"
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/internal/svc"

	"github.com/zeromicro/go-zero/core/logx"
)

type QueueJobsLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewQueueJobsLogic(ctx context.Context, svcCtx *svc.ServiceContext) *QueueJobsLogic {
	return &QueueJobsLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// QueueJobs
func (l *QueueJobsLogic) QueueJobs(in *hpcAC.QueueJobsReq) (*hpcAC.QueueJobsResp, error) {

	getTokenLogic := NewGetACTokenLogic(l.ctx, l.svcCtx)
	tokenResp, _ := getTokenLogic.GetACToken(&hpcAC.ACTokenReq{})
	token := tokenResp.GetData().Token

	url := "https://api01.hpccube.com:65106/hpc/openapi/v2/view/queue/jobs?userName=" + in.UserName
	var queueJobsResp *hpcAC.QueueJobsResp
	acHttpRequest := tool.GetACHttpRequest()
	acHttpRequest.SetHeader(tool.ContentType, tool.ApplicationJson).
		SetResult(&queueJobsResp).
		SetHeader("token", token).
		Get(url)
	return queueJobsResp, nil
}
