package logic

import (
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/internal/util"
	"context"
	"fmt"

	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/hpcAC"
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/internal/svc"

	"github.com/zeromicro/go-zero/core/logx"
)

type SelectQueueByUserLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewSelectQueueByUserLogic(ctx context.Context, svcCtx *svc.ServiceContext) *SelectQueueByUserLogic {
	return &SelectQueueByUserLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// SelectQueueByUser 查询用户可访问队列列表
func (l *SelectQueueByUserLogic) SelectQueueByUser(in *hpcAC.QueueReq) (*hpcAC.QueueResp, error) {

	resp := hpcAC.QueueResp{}
	url := fmt.Sprintf("/hpc/openapi/v2/queuenames/users/%s/?strJobManagerID=%s", in.User, in.StrJobManagerID)
	_, _ = util.Get("", l.svcCtx.Config.ClusterUrl, url, nil, nil, &resp)

	return &resp, nil
}
