package logic

import (
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/hpcAC"
	"PCM/adaptor/PCM-HPC/PCM-AC/rpc/internal/svc"
	"PCM/common/tool"
	"context"

	"github.com/zeromicro/go-zero/core/logx"
)

type WallTimeLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewWallTimeLogic(ctx context.Context, svcCtx *svc.ServiceContext) *WallTimeLogic {
	return &WallTimeLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *WallTimeLogic) WallTime(in *hpcAC.WallTimeReq) (*hpcAC.WallTimeResp, error) {

	getTokenLogic := NewGetACTokenLogic(l.ctx, l.svcCtx)
	tokenResp, _ := getTokenLogic.GetACToken(&hpcAC.ACTokenReq{})
	token := tokenResp.GetData().Token

	url := "https://api01.hpccube.com:65106/hpc/openapi/v2/view/walltime/users/" + in.Username
	var wallTimeResp *hpcAC.WallTimeResp
	acHttpRequest := tool.GetACHttpRequest()
	acHttpRequest.
		SetResult(&wallTimeResp).
		SetHeader(tool.ContentType, tool.ApplicationJson).
		SetHeader("token", token).
		Get(url)
	return wallTimeResp, nil
}
