package svc

import (
	"PCM/adaptor/PCM-CORE/rpc/pcmcoreclient"
	"PCM/adaptor/PCM-HPC/PCM-TH/rpc/internal/config"
	"github.com/robfig/cron/v3"
	"github.com/zeromicro/go-zero/zrpc"
)

type ServiceContext struct {
	Config     config.Config
	Cron       *cron.Cron
	PcmCoreRpc pcmcoreclient.PcmCore
}

func NewServiceContext(c config.Config) *ServiceContext {
	return &ServiceContext{
		Cron:       cron.New(cron.WithSeconds()),
		Config:     c,
		PcmCoreRpc: pcmcoreclient.NewPcmCore(zrpc.MustNewClient(c.PcmCoreRpcConf)),
	}
}
