package logic

import (
	"PCM/common/tool"
	"context"
	"fmt"
	"k8s.io/apimachinery/pkg/util/json"
	"strings"

	"PCM/adaptor/PCM-STORAGE/PCM-CEPH/rpc/ceph"
	"PCM/adaptor/PCM-STORAGE/PCM-CEPH/rpc/internal/svc"

	"github.com/zeromicro/go-zero/core/logx"
)

type DailyPowerScreenLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewDailyPowerScreenLogic(ctx context.Context, svcCtx *svc.ServiceContext) *DailyPowerScreenLogic {
	return &DailyPowerScreenLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *DailyPowerScreenLogic) DailyPowerScreen(in *ceph.DailyPowerScreenReq) (*ceph.DailyPowerScreenResp, error) {
	// todo: add your logic here and delete this line
	var resp ceph.DailyPowerScreenResp
	screenUrl := l.svcCtx.Config.ScreenUrl
	statusCode, body, err := tool.HttpClientWithScreen(tool.GET, screenUrl+"computepower/dailytrend", strings.NewReader(``))
	if err != nil {
		return nil, err
	}
	if statusCode == 200 {
		err := json.Unmarshal(body, &resp)
		if err != nil {
			fmt.Println(err)
		}
		fmt.Println(body)
		resp.Code = 200
		resp.Msg = "Success"
	} else if statusCode != 200 {
		json.Unmarshal(body, &resp)
		resp.Code = 400
		resp.Msg = "Failure"
	}
	return &resp, nil
}
