package logic

import (
	"PCM/common/tool"
	"context"
	"fmt"
	"k8s.io/apimachinery/pkg/util/json"
	"strings"

	"PCM/adaptor/PCM-STORAGE/PCM-CEPH/rpc/ceph"
	"PCM/adaptor/PCM-STORAGE/PCM-CEPH/rpc/internal/svc"

	"github.com/zeromicro/go-zero/core/logx"
)

type StorageScreenLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

/*type StorageArg struct {
	totalSize     int32           `json:"totalSize"`
	aiCenterInfos []AiCenterInfos `json:"aiCenterInfos"`
}

type AiCenterInfos struct {
	id   string `json:"id"`
	name string `json:"name"`
	/*	desc            string
		resource        string
		trainJob        string
		computeScale    int32
	storageScale int32 `json:"storageScale"`
	/*	province        string
		city            string
		coordinateX     int32
		coordinateY     int32
		weight          int32
		connectionState int32
		busyState       int32
		imageUrl        string
		accDevices      string
		marketTime      int64
		createdAt       int64
		accessTime      int32
		cardRunTime     int32
		jobCount        int32
}*/

func NewStorageScreenLogic(ctx context.Context, svcCtx *svc.ServiceContext) *StorageScreenLogic {
	return &StorageScreenLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// get modelarts Token
func (l *StorageScreenLogic) StorageScreen(in *ceph.StorageScreenReq) (*ceph.StorageScreenResp, error) {
	// todo: add your logic here and delete this line
	var resp ceph.StorageScreenResp
	screenUrl := l.svcCtx.Config.ScreenUrl
	statusCode, body, err := tool.HttpClientWithScreen(tool.GET, screenUrl+"aicenter?sortBy=weight&orderBy=asc", strings.NewReader(``))
	if err != nil {
		return nil, err
	}
	if statusCode == 200 {
		err := json.Unmarshal(body, &resp)
		if err != nil {
			fmt.Println(err)
		}
		var usedStorageScale int32  //已使用
		var usingStorageScale int32 //未使用
		for _, item := range resp.AiCenterInfos {
			if item.ConnectionState == 3 {
				usedStorageScale += item.StorageScale
			} else {
				usingStorageScale += item.StorageScale
			}
		}
		fmt.Println(usedStorageScale)
		fmt.Println(usingStorageScale)
		var floatUsedStorageScale float32 = float32(usedStorageScale)
		var floatUsingStorageScale float32 = float32(usingStorageScale)

		var UsageRate float32    //已使用率
		var UsingRate float32    //未使用率
		var StorageUsed float32  //已使用量
		var StorageUsing float32 //未使用量
		UsageRate = (floatUsedStorageScale*1024 + 54.6) / (floatUsedStorageScale*1024 + floatUsingStorageScale*1024 + 54.6)
		UsingRate = (floatUsingStorageScale * 1024) / (floatUsedStorageScale*1024 + floatUsingStorageScale*1024 + 54.6)
		StorageUsed = floatUsedStorageScale*1024 + 54.6
		StorageUsing = floatUsingStorageScale * 1024
		resp.UsageRate = UsageRate
		resp.UsingRate = UsingRate
		resp.StorageUsing = StorageUsing
		resp.StorageUsed = StorageUsed
		resp.Code = 200
		resp.Msg = "Success"
	} else if statusCode != 200 {
		json.Unmarshal(body, &resp)
		resp.Code = 400
		resp.Msg = "Failure"
	}
	return &resp, nil
}
